# 【子豪兄的零基础树莓派教程】第2讲：安装配置操作系统、开机、远程登录

>【子豪兄的零基础树莓派教程】第2讲：
>1、下载所需工具
>2、在microSD卡中安装Raspbian操作系统
>3、配置远程登录ssh文件和wifi文件
>4、查找树莓派ip地址，远程登录树莓派
>
>源代码、更新、勘误，请看本教程Github代码仓库：
>https://github.com/TommyZihao/ZihaoTutorialOfRaspberryPi



## 1、下载所需工具

点击[百度网盘链接](https://pan.baidu.com/s/1pL68wmzAJz3ZG7URt4191g)，下载001、002、003三个文件夹

001：基本工具：包括镜像烧录工具、局域网IP扫描器、远程文件传输工具 FileZilla、文本编辑器Notepad++、远程ssh工具putty、SD卡格式化工具 SD Formatter

002：树莓派官方操作系统Raspbian （2018年6月27日树莓派基金会发布的官方操作系统，截至本文撰写时间2018年10月12日，依旧是最新版本）

003：常用文件

> 如果百度网盘链接失效，请在微信公众号“子豪兄的科研小屋”回复“百度网盘链接001”获取最新链接。
>
> 如果001文件夹里的软件与你电脑的操作系统不兼容，可以通过官方下载链接下载对应版本：
>
> [SD卡格式化工具 SD Formatter](https://www.sdcard.org/downloads/formatter_4/)
>
> [远程文件传输工具 FileZilla](https://filezilla-project.org/download.php?type=client)



## 2、将microSD卡通过读卡器插入电脑

### ①格式化SD卡

如果是之前用过的SD卡，需要用SD Formatter工具格式化这张SD卡，如果是新SD卡，可直接进行下一步

![格式化已有的SD卡](https://upload-images.jianshu.io/upload_images/13714448-bc7215d37c39e836.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/640)



![格式化SD卡成功](https://upload-images.jianshu.io/upload_images/13714448-abf5e3f941d3016a.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/300)

### ②烧录树莓派官方操作系统Raspbian到SD卡中

![烧录树莓派操作系统镜像](https://upload-images.jianshu.io/upload_images/13714448-6d22b8fb9a2fbd6a.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)



烧录成功之后，在SD卡里就会有以下文件：

![烧录成功](https://upload-images.jianshu.io/upload_images/13714448-9acf99534895634d.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

### ③配置SSH远程登录文件和wifi文件

创建两个记事本txt文件，然后把它们的名字分别改成`ssh`和`wpa_supplicant.conf`（注意要把`.txt`扩展名删掉）

创建`ssh`文件和`wpa_supplicant.conf`空白文件

用文本编辑器Notepad++打开`wpa_supplicant.conf`,输入以下配置，可以用多个network{}来配置多个wifi：

```shell
country=GB
ctrl_interface=DIR=/var/run/wpa_supplicant GROUP=netdev
update_config=1
network={
	ssid="将我替换成第一个WiFi的名字，不删除引号,不能有中文"
	psk="将我替换成WiFi密码，不删除引号"
	priority=将我替换成数字，数字越大代表优先级越高
}
network={
	ssid="将我替换成第二个WiFi的名字，不删除引号,不能有中文"
	psk="将我替换成WiFi密码，不删除引号"
	priority=将我替换成数字，数字越大代表优先级越高
}
```

例如这样

![配置wifi文件](https://upload-images.jianshu.io/upload_images/13714448-1b37351bcd946978.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

将ssh空白文件和wpa_supplicant.conf文件放入boot盘中

![将ssh文件和wpa_supplicant.conf文件放入boot盘中](https://upload-images.jianshu.io/upload_images/13714448-70819fe7ad131c4c.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)



## 3、树莓派开机及获取ip地址



### ①拔出SD卡，插入树莓派，插好HDMI显示屏线和电源线，通电

树莓派上的红灯常亮，表示通电。绿灯间歇性亮，表示读写SD卡。



### ②获取树莓派ip地址的N种方法

知道了树莓派ip地址，就可以用我们的笔记本电脑远程登录树莓派，有很多种方法可以直接获取树莓派的ip地址：

1. 如果树莓派连接到了显示屏上，可以直接鼠标指向右上角网络图标，ip地址会自动显示

2. 如果树莓派连接到了显示屏上，可以打开树莓派命令行窗口，输入`ifconfig`

3. 如果没有显示屏，用手机连到与树莓派同一个网络的wifi下，打开dataplicity应用上扫描出树莓派的ip地址

4. 如果没有显示屏，用电脑连到与树莓派同一个网络的wif或者有线网络下，在电脑上打开局域网ip扫描器，扫描出树莓派ip地址

5. 查看开wifi的路由器后台配置界面，找到树莓派，查看ip地址

   以下为大神级操作，新手看看就好：

6. 高能操作之一：让树莓派每次开机之后发一封包含自己ip地址的邮件到你的qq邮箱：[让树莓派说出自己的ip地址](https://www.cnblogs.com/ma6174/archive/2013/09/29/3345278.html)

7. 高能操作之二：让树莓派每次开机之后自动开启一个FM广播台，你可以用收音机听到内容：[Bilibili视频：【熟肉】教你用树莓派制作可以进行语音直播的FM调频无线电台](https://www.bilibili.com/video/av23299793/?spm_id_from=333.788.videocard.1)

8. 高能操作之三：对树莓派LED灯的闪灭进行编码，通过长短信号表示指定ip地址的数字



## 4、远程登录树莓派

通过远程ssh工具putty和远程桌面工具VNC Viewer远程登录树莓派











![](https://upload-images.jianshu.io/upload_images/13714448-1c1f91c8b56023a9.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

![微信扫码支持子豪兄制作树莓派教程](https://upload-images.jianshu.io/upload_images/13714448-4be7dc29e22207b4.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/300)



## 扩展阅读与参考文献

> [如果没有显示器如何愉快玩树莓派｜明明白白玩 Pi 系列之二](https://sspai.com/post/38780)
>
> [树莓派食用指南（一）：没有显示器也能玩转树莓派](https://www.maxoyed.com/archives/84/)
>
> [让树莓派说出自己的ip地址](https://www.cnblogs.com/ma6174/archive/2013/09/29/3345278.html)
>
> [Bilibili视频：【熟肉】教你用树莓派制作可以进行语音直播的FM调频无线电台](https://www.bilibili.com/video/av23299793/?spm_id_from=333.788.videocard.1)



![树莓派接线](https://projects-static.raspberrypi.org/projects/raspberry-pi-getting-started/13aeb423985e6bacd5d798f5f206a644b7c250a3/en/images/pi-plug-in.gif)

![欢迎加入树莓派全球开源社区](https://upload-images.jianshu.io/upload_images/13714448-9413183a2d79c2a8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)
