# 树莓派新手无痛开机指南【树莓派趣味编程，从ABC到XYZ】

树莓派从拆快递到开机的全过程，包括硬件准备、软件准备、SD卡准备、烧录镜像、配置wifi、获取ip地址、远程登陆，并配有手把手教学视频。

> [本文配套B站视频——【树莓派趣味编程，从ABC到XYZ】第2讲：树莓派新手无痛开机指南](https://www.bilibili.com/video/av33569265)        
>
> **看完视频后食用本文更佳**
>
> 作者：张子豪（同济大学在读研究生）  

-   [树莓派新手无痛开机指南【树莓派趣味编程，从ABC到XYZ】](#树莓派新手无痛开机指南树莓派趣味编程从abc到xyz)
-   [准备](#准备)
    -   [硬件准备](#硬件准备)
    -   [软件准备](#软件准备)
    -   [格式化SD卡](#格式化sd卡)
-   [在SD卡中烧录树莓派镜像（操作系统）](#在sd卡中烧录树莓派镜像操作系统)
    -   [烧录镜像](#烧录镜像)
    -   [将空白的ssh文件放入SD卡的`boot`盘](#将空白的ssh文件放入sd卡的boot盘)
    -   [配置wifi文件，放入SD卡的`boot`盘](#配置wifi文件放入sd卡的boot盘)
    -   [一窥Linux文件树](#一窥linux文件树)
-   [树莓派开机](#树莓派开机)
    -   [通电启动](#通电启动)
    -   [获取树莓派ip的n种方法](#获取树莓派ip的n种方法)
    -   [远程登录树莓派](#远程登录树莓派)
    -   [扩展阅读与参考文献](#扩展阅读与参考文献)

[TOC]

本教程凝聚了无数资深玩家多年经验心得，不看会吃亏的哦~

![跳过教程的玩家](https://upload-images.jianshu.io/upload_images/13714448-5c67e73d45c4f410.jpg?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

# 准备

## 硬件准备

SD卡（小卡）、读卡器、树莓派电源或安卓手机电源、一台电脑

可以没有显示屏，可以没有鼠标键盘。

## 软件准备

电脑里下载好这个百度网盘链接里的三个压缩包，解压。

>链接：https://pan.baidu.com/s/1KBNP6DGBLRKa2jktD2vq0A 
>提取码：z8rz 
>
>如果百度网盘链接失效，请在bilibili视频专栏[同济子豪兄](https://space.bilibili.com/1900783)对应视频评论区获取最新链接。

共有三个文件夹：基本工具、树莓派镜像文件、常用文件

- 001：基本工具：包括镜像烧录工具、局域网IP扫描器、远程文件传输工具 FileZilla、文本编辑器Notepad++、远程ssh工具putty、SD卡格式化工具 SD Formatter

  >如果001文件夹里的软件与你电脑的操作系统不兼容，可以通过官方下载链接下载对应版本：
  >
  >[SD卡格式化工具 SD Formatter](https://www.sdcard.org/downloads/formatter_4/)
  >
  >[远程文件传输工具 FileZilla](https://filezilla-project.org/download.php?type=client)

- 002：树莓派官方操作系统Raspbian （2018年6月27日树莓派基金会发布的官方操作系统，截至本文撰写时间2018年10月12日，依旧是最新版本）

- 003：开机常用文件，包括`ssh`空文件和wifi配置文件

逐个安装基本工具里的软件：balena-etcher、Linux-Reader、notepad++、putty、VNC-Viewer

## 格式化SD卡

如果SD卡是旧卡，需要用SDFormatter格式化工具先格式化。如果用新的SD卡可以跳过此步。

格式化SD卡：

![格式化已有的SD卡](https://upload-images.jianshu.io/upload_images/13714448-bc7215d37c39e836.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/640)



![格式化SD卡成功](https://upload-images.jianshu.io/upload_images/13714448-abf5e3f941d3016a.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/300)

格式化之后，可以看到SD卡对应的盘变成了空盘。

# 在SD卡中烧录树莓派镜像（操作系统）

## 烧录镜像

找到下载文件中的镜像文件`2018-11-13-raspbian-stretch.iso`文件

打开镜像烧录工具Win32DiskImager（或者另一个镜像烧录工具balena-etcher），选好镜像文件和要烧录的SD卡对应的盘。

> 选SD卡对应盘符号的时候一定要小心，不要选到其它盘或者硬件，不然镜像可能会覆盖写到其它盘里。

然后点击`write`，开始烧录。

![烧录树莓派操作系统镜像](https://upload-images.jianshu.io/upload_images/13714448-6d22b8fb9a2fbd6a.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

烧录成功之后，在SD卡里就会有以下文件：

![烧录成功](https://upload-images.jianshu.io/upload_images/13714448-9acf99534895634d.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

## 将空白的ssh文件放入SD卡的`boot`盘

手动创建一个空白记事本`.txt`文件，命名为`ssh`，重命名，删掉.txt扩展名。将这个文件放入SD卡的`boot`盘中。

> 我已经在003文件夹中创建好了`ssh`文件，你可以直接把这个文件复制到SD卡的`boot`盘中。

## 配置wifi文件，放入SD卡的`boot`盘

用同样的方法新建一个空白文件`wpa_supplicant.conf`（注意要删掉扩展名.txt）

用文本编辑器打开`wpa_supplicant.conf`,输入以下配置，可以用多个network{}来配置多个wifi：

```shell
country=GB
ctrl_interface=DIR=/var/run/wpa_supplicant GROUP=netdev
update_config=1
network={
	ssid="将我替换成第一个WiFi的名字，不删除引号,不能有中文"
	psk="将我替换成WiFi密码，不删除引号"
	priority=将我替换成数字，数字越大代表优先级越高
}
network={
	ssid="将我替换成第二个WiFi的名字，不删除引号,不能有中文"
	psk="将我替换成WiFi密码，不删除引号"
	priority=将我替换成数字，数字越大代表优先级越高
}
```

比如我家里的Wifi叫`rich`，wifi密码是`rich1187`，寝室的WiFi叫`wangda`，Wifi密码是`DalexWang199432`，我就可以这样写。

> priority表示几个wifi同时都搜得到的时候优先连接哪个。

![配置wifi文件](https://upload-images.jianshu.io/upload_images/13714448-1b37351bcd946978.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

将`ssh`空白文件和`wpa_supplicant.conf`文件放入SD卡的`boot`盘中。

![将ssh文件和wpa_supplicant.conf文件放入boot盘中](https://upload-images.jianshu.io/upload_images/13714448-70819fe7ad131c4c.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

## 一窥Linux文件树

在windows的资源管理器中看不到SD卡里的linux文件，我们可以用linux-reader工具查看

![使用linux-reader查看SD卡中linux目录下的文件](https://upload-images.jianshu.io/upload_images/13714448-37fd60b84d671426.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

![SD卡中linux目录下的文件](https://upload-images.jianshu.io/upload_images/13714448-5144e9282c7d66b3.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

下一步，就可以给树莓派开机了

拔出SD卡，插到树莓派的SD卡槽里，插好HDMI显示屏线和电源线，通电



# 树莓派开机

## 通电启动

从电脑上拔出SD卡，插入树莓派，插好HDMI显示屏线（如果有显示屏）和电源线，通电。

树莓派上的红灯常亮，表示通电。绿灯间歇性亮，表示读写SD卡。

给树莓派通电，如果绿灯闪烁，屏幕上显示出树莓派的logo，说明操作系统正常。

## 获取树莓派ip的n种方法

知道了树莓派ip地址，就可以用我们的笔记本电脑远程登录树莓派，有很多种方法可以直接获取树莓派的ip地址：

1. 如果树莓派连接到了显示屏上，可以直接鼠标指向右上角网络图标，ip地址会自动显示

2. 如果树莓派连接到了显示屏上，可以打开树莓派命令行窗口，输入`ifconfig`

3. 如果没有显示屏，用手机连到与树莓派同一个网络的wifi下，打开苹果手机APP`dataplicity`应用上扫描出树莓派的ip地址

   ![苹果手机app dataplicity](https://upload-images.jianshu.io/upload_images/13714448-c6c8a8d293f5f456.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

4. 如果没有显示屏，用电脑连到与树莓派同一个网络的wif或者有线网络下，在电脑上打开局域网ip扫描器，扫描出树莓派ip地址

5. 查看开wifi的路由器后台配置界面，找到树莓派，查看ip地址

   以下为大神级操作，新手看看就好：

6. 高能操作之一：让树莓派每次开机之后发一封包含自己ip地址的邮件到你的qq邮箱：[让树莓派说出自己的ip地址](https://www.cnblogs.com/ma6174/archive/2013/09/29/3345278.html)

7. 高能操作之二：让树莓派每次开机之后自动开启一个FM广播台，你可以用收音机听到内容：[Bilibili视频：【熟肉】教你用树莓派制作可以进行语音直播的FM调频无线电台](https://www.bilibili.com/video/av23299793/?spm_id_from=333.788.videocard.1)

8. 高能操作之三：对树莓派LED灯的闪灭进行编码，通过长短信号表示指定ip地址的数字。注意：请遵守国家相关无线电管理条例和法律法规。



## 远程登录树莓派

现在，可以通过远程ssh工具putty远程登陆树莓派了。

例如，如果树莓派的ip地址是192.168.200.196

![putty登陆树莓派](https://upload-images.jianshu.io/upload_images/13714448-917f818a5a1976d3.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)


![putty登陆树莓派](https://upload-images.jianshu.io/upload_images/13714448-216dfed7b5472d1e.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

请看下一讲：一劳永逸配置树莓派。

![微信扫码支持子豪兄制作树莓派教程](https://upload-images.jianshu.io/upload_images/13714448-4be7dc29e22207b4.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/300)

## 扩展阅读与参考文献

> [如果没有显示器如何愉快玩树莓派｜明明白白玩 Pi 系列之二](https://sspai.com/post/38780)
>
> [树莓派食用指南（一）：没有显示器也能玩转树莓派](https://www.maxoyed.com/archives/84/)
>
> [让树莓派说出自己的ip地址](https://www.cnblogs.com/ma6174/archive/2013/09/29/3345278.html)
>
> [Bilibili视频：【熟肉】教你用树莓派制作可以进行语音直播的FM调频无线电台](https://www.bilibili.com/video/av23299793/?spm_id_from=333.788.videocard.1)

![子豪兄的树莓派系列教程](https://upload-images.jianshu.io/upload_images/13714448-bc64c10051174fde.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

![树莓派接线](https://upload-images.jianshu.io/upload_images/13714448-d706c8c62aa45125.gif?imageMogr2/auto-orient/strip%7CimageView2/2/w/842/format/webp)

![欢迎加入树莓派全球开源社区](https://upload-images.jianshu.io/upload_images/13714448-9413183a2d79c2a8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)
