> 对新安装系统的树莓派进行一系列一劳永逸的设置，包括软件换源、设置密码、国家、时区、开启功能，下载安装中文字体及输入法、远程桌面工具，及其它常用软件。<br>
>
> 经过了本文一劳永逸的配置，你就可以开启接下来的树莓派玩转之旅了。<br>
>
> 上一步：[第二讲：树莓派开机指南](<https://github.com/TommyZihao/ZihaoTutorialOfRaspberryPi/blob/master/%E7%AC%AC2%E8%AE%B2%EF%BC%9A%E6%A0%91%E8%8E%93%E6%B4%BE%E6%96%B0%E6%89%8B%E6%97%A0%E7%97%9B%E5%BC%80%E6%9C%BA%E6%8C%87%E5%8D%97.md>)<br>
>
> 下一步：第四讲：探索树莓派的桌面<br>
>
> [本文配套B站视频：子豪兄的树莓派零基础教程](https://space.bilibili.com/1900783/#/)<br>

第3讲：一劳永逸配置树莓派【子豪兄的树莓派零基础教程】<br>

作者：张子豪（同济大学在读研究生）<br>

文字版、源代码、更新、勘误，请看[本教程Github代码仓库](https://github.com/TommyZihao/ZihaoTutorialOfRaspberryPi)<br>

知乎、简书专栏：**人工智能小技巧**<br>

# B站粉丝QQ群号：`953712961`

# 目录

-   [PuTTY工具永久修改字体大小](#putty工具永久修改字体大小)
-   [换源：将下载源从树莓派默认国外源切换到国内清华大学开源软件镜像站](#换源将下载源从树莓派默认国外源切换到国内清华大学开源软件镜像站)
    -   [给`Raspbian`的包管理器`apt-get`换源](#给raspbian的包管理器apt-get换源)
    -   [给`Python`的第三方模块安装工具`pip`换源](#给python的第三方模块安装工具pip换源)
        -   [方法一：一行命令换源](#方法一一行命令换源)
        -   [方法二：配置换源脚本](#方法二配置换源脚本)
-   [树莓派内部配置](#树莓派内部配置)
    -   [第一行：`Change User Password`修改密码](#第一行change-user-password修改密码)
    -   [第四行：`Localisation Options`选择地区](#第四行localisation-options选择地区)
        -   [第一行：`Change Locale`选择所在国家](#第一行change-locale选择所在国家)
        -   [第二行：`Change Timezone`选择所在时区](#第二行change-timezone选择所在时区)
        -   [第四行：`Change Wi-fi Country`选择wifi国家](#第四行change-wi-fi-country选择wifi国家)
    -   [第五行：`Interfacing Options`开启功能](#第五行interfacing-options开启功能)
    -   [第七行：`Advanced Options`高级设置](#第七行advanced-options高级设置)
-   [下载安装常用软件](#下载安装常用软件)
    -   [安装中文字体及输入法](#安装中文字体及输入法)
    -   [安装远程桌面登陆软件`teamviewer`](#安装远程桌面登陆软件teamviewer)
-   [安装其它软件](#安装其它软件)
-   [升级所有安装的软件](#升级所有安装的软件)
-   [参考资料与扩展阅读](#参考资料与扩展阅读)

> 本教程是无数树莓派玩家多年总结的必由之路，凝聚了无数前人趟坑的血泪和汗水。特别适合新手阅读。配合视频教程食用更佳。[本文配套B站视频：子豪兄的树莓派零基础教程](https://space.bilibili.com/1900783/#/)

![跳过教程的玩家](https://upload-images.jianshu.io/upload_images/13714448-5c67e73d45c4f410.jpg?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)



# PuTTY工具永久修改字体大小

[CSDN博客：PUTTY中永久更改字体大小](<https://blog.csdn.net/u012810488/article/details/41597395>)<br>

# 换源：将下载源从树莓派默认国外源切换到国内清华大学开源软件镜像站

树莓派默认的下载源是国外的源，每次下载都要远隔重洋获取资源，速度自然是龟速，为了解决这个问题，我们可以从国内已经下载了这些资源的人那里获取，比如说，清华大学开源软件镜像站。

![国内镜像站的原理](https://upload-images.jianshu.io/upload_images/13714448-2e6db123ac6960c8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

> 为什么叫`镜像`，是因为镜像站每隔一段时间（几分钟）便会使自己和国外源保持同步，维持和国外源一模一样的软件资源列表，就像照镜子一样。<br>
>
> 本文将在树莓派上配置`apt-get`包管理器的镜像和python第三方库下载工具`pip`的镜像到国内镜像站，除此之外，`node.js（npm）`等众多编程语言也可以设置国内镜像。<br>
>
> 除了[清华大学开源软件镜像站](<https://mirrors.tuna.tsinghua.edu.cn/>)之外，还有很多国内镜像站，比如阿里云、同济大学、重庆大学、中科大、豆瓣、淘宝等。



## 给`Raspbian`的包管理器`apt-get`换源

在树莓派的命令行界面输入

```shell
sudo nano /etc/apt/sources.list
```

使用键盘方向键控制，在第一行开头加一个`#`，把下面的内容拷贝到最后一行之后，如图中的效果：

```shell
deb http://mirrors.tuna.tsinghua.edu.cn/raspbian/raspbian/ stretch main contrib non-free rpi
deb-src http://mirrors.tuna.tsinghua.edu.cn/raspbian/raspbian/ stretch main contrib non-free rpi
```

![换国内源](https://upload-images.jianshu.io/upload_images/13714448-6e15c90b0aa7acb5.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

先按键盘上的`ctrl`+`o`，再按回车保存，再按`ctrl`+`x`退出nano编辑器回到命令行界面。再输入以下命令更新到清华大学镜像源最新的软件列表。

```shell
sudo apt-get update 
```

这个命令，会访问源列表里的每个网址，并读取软件列表，然后保存在树莓派本地。
> 以上步骤实现了Respbian的包管理器`apt-get`换源到清华大学软件镜像站，并更新了软件列表，今后在树莓派命令行中执行`sudo apt-get install 软件名`时便会自动从清华大学开源软件镜像站高速下载。

## 给`Python`的第三方模块安装工具`pip`换源

### 方法一：一行命令换源

> 清华大学开源软件镜像站官方推荐方法，但该方法在树莓派上可能会失效。

只需树莓派命令行中输入下面这一行命令，即可永久设置pip下载源为国内源

```shell
pip config set global.index-url https://pypi.tuna.tsinghua.edu.cn/simple
```

> 注意：是 `https` 而不是 `http`，`simple` 不能少

### 方法二：配置换源脚本

该方法在树莓派上亲测有效

在树莓派的命令行中依次输入运行以下三个命令

```shell
sudo mkdir ~/.pip
cd .pip
sudo nano pip.conf
```

在打开的文件中输入以下内容：

```shell
[global]
timeout = 10
index-url =  http://mirrors.aliyun.com/pypi/simple/
extra-index-url= http://pypi.douban.com/simple/
[install]
trusted-host=
    mirrors.aliyun.com
    pypi.douban.com
```

先按键盘上的`ctrl`+`o`，再按回车保存，再按`ctrl`+`x`退出nano编辑器回到命令行界面。



# 树莓派内部配置

打开树莓派命令行界面输入命令，进入树莓派配置界面。

```shell
sudo raspi-config
```

![树莓派配置界面](https://upload-images.jianshu.io/upload_images/13714448-59742b839ab0c666.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

用上下键和左右键切换光标位置。

### 第一行：`Change User Password`修改密码

按照里面的要求修改成自己的密码即可。默认用户名为`pi`，密码为`raspberry`<br>

这个密码会用于远程ssh登陆、VNC远程桌面及需要管理员root权限时输入。<br>

### 第四行：`Localisation Options`选择地区

![Localisation Options](https://upload-images.jianshu.io/upload_images/13714448-b48ae582572cdfdf.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

#### 第一行：`Change Locale `选择所在国家

这是一串很长的列表，到这个列表的最下面，让光标指在zh_CN.UTF-8 UTF-8前面，先按空格，再按回车，回到之前的界面再按回车。

![此时再按回车](https://upload-images.jianshu.io/upload_images/13714448-b1dbcf02b13931d0.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

重新选择第四行`Localisation Options`

#### 第二行：`Change Timezone `选择所在时区

选择`Asia`，再选择`Shanghai`，回车确定。

![选择Asia](https://upload-images.jianshu.io/upload_images/13714448-04ab876253408fc5.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

![选择Shanghai](https://upload-images.jianshu.io/upload_images/13714448-53862520982039df.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)



#### 第四行：`Change Wi-fi Country `选择wifi国家

选择`CN China`，回车

![选择Wifi国家](https://upload-images.jianshu.io/upload_images/13714448-3f99f1c817ce7396.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)



### 第五行：`Interfacing Options`开启功能

![Interfacing Options](https://upload-images.jianshu.io/upload_images/13714448-e4c334e40682f5c2.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

打开`Camera`、`SSH`、`VNC`、`Serial`、`Remote GPIO`。<br>

> 这几个功能都是我们在以后会用到的功能。
>
> Camera：摄像头
>
> SSH：ssh远程通信与登陆
>
> VNC：VNC远程桌面登陆
>
> Serial：串口控制
>
> Remote GPIO：远程GPIO引脚控制

### 第七行：`Advanced Options`高级设置

![Adcanved Options](https://upload-images.jianshu.io/upload_images/13714448-1d3bb4659426dce8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

- 选择`Expand Filesystem`，将根目录扩展到这个SD卡，充分利用SD卡的存储空间

- 选择`Overscan`，在整个屏幕上显示

- 选择`Audio`，选择`Force 3.5mm('headphone' jack)`，树莓派的声音会从耳机孔输出

- 选择`Resolution`，选择默认设置，自动根据显示屏调整分辨率

- 选择`Pixel Doubling`，增加桌面显示画质

  选择`Finish`，会跳出对话框问是否重新启动，可以直接回车确定重启，也可以等下次启动时候生效。



# 下载安装常用软件

## 安装中文字体及输入法

打开树莓派命令行，输入以下命令

```shell
sudo apt-get install fonts-wqy-zenhei
```

> 这行命令里的`sudo`表示使用管理员root权限，`apt-get`表示使用apt-get包管理器来下载，`install`表示下载安装，`fonts-wqy-zenhei`表示软件名字。之后所有的`sudo apt-get install 软件名`都表示这样的意思。

接下来，安装中文输入法fcitx及Google拼音输入法（大约需要五分钟）

```shell
sudo apt-get install fcitx fcitx-googlepinyin fcitx-module-cloudpinyin fcitx-sunpinyin
```

在跳出的对话框中输入`y`和回车`↩`，确定下载安装，需要90MB存储空间。<br>

安装成功之后，会在下一次重启时生效。<br>

可以使用`ctrl`+`空格`切换为中文输入法。<br>

## 安装远程桌面登陆软件`teamviewer`

我们已经在电脑上使用过`VNC Viewer`，远程到树莓派桌面进行控制，但这仅适用于你的电脑或手机与树莓派在同一个局域网下（比如都连着家里同一个wifi）的情况。树莓派一旦连到其它外网，ip地址便是另一个子网下的ip地址，在原来的局域网中是访问不到的，为了解决这个问题，人们采用内网穿透技术。

这个技术名字听起来很高大上，其实本质上依旧是通过一个中间代理来传小纸条。

我们下载安装的远程桌面控制软件teamviewer，就是这么一个在我们和树莓派之间传小纸条的中间人。

![国内镜像站的原理](https://upload-images.jianshu.io/upload_images/13714448-2e6db123ac6960c8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

安装teamviewer，只需依次执行下列五条命令。在运行第二条命令的时候会显示很多依赖包没有安装，不要慌，第三条命令就是用来干这个的。

如果命令执行过程中跳出对话框，则输入`y`和回车`↩`，确定下载安装

```shell
wget http://download.teamviewer.com/download/linux/version_11x/teamviewer-host_armhf.deb

sudo dpkg -i teamviewer-host_armhf.deb

sudo apt-get -f install

sudo apt-get install gdebi

sudo gdebi teamviewer-host_armhf.deb
```

在命令行中输入

`teamviewer info`可以查看teamviewer当前版本

在跳出的对话框选择`Accept License Agreement`

![teamviewer对话框](https://upload-images.jianshu.io/upload_images/13714448-2bd262010506fd1d.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)



在树莓派桌面，右上角可以看到teamviewer的图标了，点击进入。再点击Grant easy access，登录你的teamviewer账户，设置连接密码。通过那一串数字（如图中的1112747434），就可以让全世界任意一台上网的电脑或手机远程桌面操控你的树莓派了。

![登录teamviewer账户](https://upload-images.jianshu.io/upload_images/13714448-2830f9965d4f0ce1.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

![点击小齿轮图标，设置](https://upload-images.jianshu.io/upload_images/13714448-d5d8b43ba0bf11b9.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

![设置连接密码](https://upload-images.jianshu.io/upload_images/13714448-3dbed8171117ba60.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)







之后，通过TeamViewer屏幕上的数字（在本例中是1112747434），你就可以使用世界上任何一台能上网的手机或电脑远程登陆树莓派的远程桌面。



# 安装其它软件

安装桌面控件`wbar`和`conky`，美化桌面。

```shell
sudo apt-get install wbar wbar-config

sudo apt-get install conky

wget -O /home/pi/.conkyrc https://raw.githubusercontent.com/novaspirit/rpi_conky/master/rpi3_conkyrc

wbar

conky
```
> 注意，`wbar`命令和`conky`命令必须在树莓派带桌面的命令行下运行。

![树莓派带桌面的命令行界面](https://upload-images.jianshu.io/upload_images/13714448-505097b76d563bf3.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

在wbar-config中配置wbar。勾选`Vertical bar`。
![wbar-config配置](https://upload-images.jianshu.io/upload_images/13714448-a48fca5bb96bc8e8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)
![桌面控件conky](https://upload-images.jianshu.io/upload_images/13714448-b17e2acf121d469a.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)



# 升级所有安装的软件

运行下面这行命令，会把本地已安装的软件，与刚下载的软件列表里对应软件进行对比，如果发现已安装的软件版本太低，就会提示你更新。执行这行命令可能需要很长时间。

```shell
sudo apt-get upgrade 
```

> 我们刚刚还运行了`sudo apt-get update`命令，现在运行`sudo apt-get upgrade`命令，有什么不同呢？
>
> 答：`update`仅仅是从下载源获取并更新可下载软件列表，相当于更新索引地图。而`upgrade`是更新软件本身。后者要花费多得多的时间。



# 参考资料与扩展阅读

[使用wbar和conky配置美化树莓派桌面](https://www.bilibili.com/video/av12410182?from=search&seid=4405360568676091304)   

[桌面控件conky的github链接](https://github.com/ccrisan/motioneyeos)     

[/etc/apt/sources.list 详解](<https://blog.csdn.net/gong_xucheng/article/details/53886271>)     

[清华大学开源软件镜像站](<https://mirrors.tuna.tsinghua.edu.cn/>)<br>   



![树莓派接线](https://projects-static.raspberrypi.org/projects/raspberry-pi-getting-started/13aeb423985e6bacd5d798f5f206a644b7c250a3/en/images/pi-plug-in.gif)

![欢迎加入树莓派全球开源社区](https://upload-images.jianshu.io/upload_images/13714448-9413183a2d79c2a8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)
